## cpp-hocon 0.1.6

=== CMakeLists.txt ===
# Defines how cmake should behave, and the minimum version necessary to build.
cmake_minimum_required(VERSION 3.2.2)

# Project Setup - modify to match project naming
## Source code for a simple command-line executable for a dynamic library will be generated from the project name.
## The command-line and library names will be based off the project name.
project(cpp-hocon VERSION 0.1.6)

string(MAKE_C_IDENTIFIER ${PROJECT_NAME} PROJECT_C_NAME)
string(TOUPPER ${PROJECT_C_NAME} PROJECT_NAME_UPPER)
string(TOLOWER ${PROJECT_C_NAME} PROJECT_NAME_LOWER)

# Common cmake setup
if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "Defaulting to a release build.")
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

enable_testing()

# Leatherman setup
set(LEATHERMAN_COMPONENTS locale catch nowide util)
find_package(Leatherman REQUIRED COMPONENTS ${LEATHERMAN_COMPONENTS})

## Before we find any packages, we want to pull in the common leatherman options, as they can affect commonly-used packages.
include(options)
## Pull in common cflags setting from leatherman. Don't override CMAKE_CXX_FLAGS at the project root to avoid impacting 3rd party code.
include(cflags)
set(${PROJECT_NAME_UPPER}_CXX_FLAGS "${LEATHERMAN_CXX_FLAGS}")
add_definitions(${LEATHERMAN_DEFINITIONS})

if(LEATHERMAN_USE_LOCALES)
    add_definitions(-DLEATHERMAN_I18N)
endif()

## Pull in helper macros for working with leatherman libraries
include(leatherman)

if(LEATHERMAN_USE_LOCALES)
    set(BOOST_COMPONENTS locale)
else()
    set(BOOST_COMPONENTS regex)
endif()

list(APPEND BOOST_COMPONENTS thread date_time chrono system program_options)

# Add other dependencies
find_package(Boost 1.54 REQUIRED COMPONENTS ${BOOST_COMPONENTS})

# pthreads if you require the Boost.Thread component.
find_package(Threads)

# Display a summary of the features
include(FeatureSummary)
feature_summary(WHAT ALL)

# Add cpplint and cppcheck targets
file(GLOB_RECURSE ALL_SOURCES lib/src/*.cc lib/inc/*.hpp exe/*.cc)
add_cpplint_files(${ALL_SOURCES})
enable_cpplint()

add_subdirectory(lib)
add_subdirectory(locales)

add_cppcheck_dirs("${PROJECT_SOURCE_DIR}/lib" "${PROJECT_SOURCE_DIR}/exe")
enable_cppcheck()

=== debian/changelog ===
cpp-hocon (0.1.6-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Fix versioned build-dependency constraints

 -- Nicolas Dandrimont <olasd@debian.org>  Sat, 31 Mar 2018 21:25:50 +0200

cpp-hocon (0.1.6-1) unstable; urgency=medium

  * Initial release (Closes: #891528)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Sat, 24 Feb 2018 23:44:54 +0200

=== debian/control ===
Source: cpp-hocon
Priority: optional
Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends: debhelper (>= 11~),
 cmake,
 libleatherman-dev,
 libboost-program-options-dev,
 catch (>= 1.10~),
Standards-Version: 4.1.3
Section: libs
Homepage: https://github.com/puppetlabs/cpp-hocon
Vcs-Git: https://salsa.debian.org/puppet-team/cpp-hocon.git -b stretch-backports
Vcs-Browser: https://salsa.debian.org/puppet-team/cpp-hocon

Package: libcpp-hocon-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcpp-hocon0.1.6 (= ${binary:Version}), ${misc:Depends}
Description: C++ port of the TypesafeConfig library -- development files
 cpp-hocon is a port of the TypsafeConfig library to C++. It provides support
 for the HOCON configuration file format. HOCON aims to keep the semantics
 (tree structure; set of types; encoding/escaping) from JSON, but make it more
 convenient as a human-editable config file format.
 .
 This package contains cpp-hocon's development headers.

Package: libcpp-hocon0.1.6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ port of the TypesafeConfig library -- shared libraries
 cpp-hocon is a port of the TypsafeConfig library to C++. It provides support
 for the HOCON configuration file format. HOCON aims to keep the semantics
 (tree structure; set of types; encoding/escaping) from JSON, but make it more
 convenient as a human-editable config file format.
 .
 This package contains the shared library.

## cpp-hocon 0.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # Project Setup - modify to match project naming
 ## Source code for a simple command-line executable for a dynamic library will be generated from the project name.
 ## The command-line and library names will be based off the project name.
-project(cpp-hocon VERSION 0.1.6)
+project(cpp-hocon VERSION 0.1.7)
 
 string(MAKE_C_IDENTIFIER ${PROJECT_NAME} PROJECT_C_NAME)
 string(TOUPPER ${PROJECT_C_NAME} PROJECT_NAME_UPPER)

=== lib/tests/CMakeLists.txt ===
# Setup compiling the test executable. C++ compile flags are inherited from the parent directory.
include_directories(${LEATHERMAN_CATCH_INCLUDE})

set(TEST_CASES
    concatenation_test.cc
    config_document_parser_test.cc
    config_node_test.cc
    config_value_test.cc
    path_test.cc
    token_test.cc
    tokenizer_test.cc
    test_utils.cc
    config_document_tests.cc
    conf_parser_test.cc
    config_substitution_test.cc
    config_value_factory_test.cc
    config_test.cc
    program_options.cc
)

add_executable(lib${PROJECT_NAME}_test $<TARGET_OBJECTS:libprojectsrc> ${TEST_CASES} main.cc)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
    target_link_libraries(lib${PROJECT_NAME}_test rt)
endif()

target_link_libraries(lib${PROJECT_NAME}_test
    ${Boost_LIBRARIES}
    ${LEATHERMAN_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND BOOST_STATIC AND LEATHERMAN_USE_LOCALES)
    target_link_libraries(lib${PROJECT_NAME}_test iconv)
endif()

add_test(NAME "unit_tests" COMMAND lib${PROJECT_NAME}_test)

configure_file (
    "${CMAKE_CURRENT_LIST_DIR}/fixtures.hpp.in"
    "${CMAKE_CURRENT_LIST_DIR}/fixtures.hpp"
)

=== debian/changelog ===
cpp-hocon (0.1.7-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:10:53 +0000

cpp-hocon (0.1.7-1) unstable; urgency=medium

  [ Nicolas Dandrimont ]
  * Fix versioned build-dependency constraints

  [ Apollon Oikonomopoulos ]
  * New upstream release
    + Bump libcpp-hocon ABI version
  * Fix FTBFS with GCC 8 (Closes: #897729)
  * Bump Standards-Version to 4.2.0; no changes needed

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 23 Aug 2018 10:18:34 +0300

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,24 @@
 Source: cpp-hocon
 Priority: optional
-Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
 Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
 Build-Depends: debhelper (>= 11~),
  cmake,
  libleatherman-dev,
  libboost-program-options-dev,
  catch (>= 1.10~),
-Standards-Version: 4.1.3
+Standards-Version: 4.2.0
 Section: libs
 Homepage: https://github.com/puppetlabs/cpp-hocon
-Vcs-Git: https://salsa.debian.org/puppet-team/cpp-hocon.git -b stretch-backports
+Vcs-Git: https://salsa.debian.org/puppet-team/cpp-hocon.git
 Vcs-Browser: https://salsa.debian.org/puppet-team/cpp-hocon
 
 Package: libcpp-hocon-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcpp-hocon0.1.6 (= ${binary:Version}), ${misc:Depends}
+Depends: libcpp-hocon0.1.7 (= ${binary:Version}), ${misc:Depends}
 Description: C++ port of the TypesafeConfig library -- development files
  cpp-hocon is a port of the TypsafeConfig library to C++. It provides support
  for the HOCON configuration file format. HOCON aims to keep the semantics
@@ -26,7 +27,7 @@
  .
  This package contains cpp-hocon's development headers.
 
-Package: libcpp-hocon0.1.6
+Package: libcpp-hocon0.1.7
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

## cpp-hocon 0.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # Project Setup - modify to match project naming
 ## Source code for a simple command-line executable for a dynamic library will be generated from the project name.
 ## The command-line and library names will be based off the project name.
-project(cpp-hocon VERSION 0.1.7)
+project(cpp-hocon VERSION 0.3.0)
 
 string(MAKE_C_IDENTIFIER ${PROJECT_NAME} PROJECT_C_NAME)
 string(TOUPPER ${PROJECT_C_NAME} PROJECT_NAME_UPPER)
@@ -37,12 +37,12 @@
 include(leatherman)
 
 if(LEATHERMAN_USE_LOCALES)
-    set(BOOST_COMPONENTS locale)
+    set(BOOST_COMPONENTS locale regex)
 else()
     set(BOOST_COMPONENTS regex)
 endif()
 
-list(APPEND BOOST_COMPONENTS thread date_time chrono system program_options)
+list(APPEND BOOST_COMPONENTS thread date_time chrono filesystem system program_options)
 
 # Add other dependencies
 find_package(Boost 1.54 REQUIRED COMPONENTS ${BOOST_COMPONENTS})

=== lib/CMakeLists.txt ===
include(leatherman)
get_commit_string(PROJECT_COMMIT)

# Generate a file containing the above version numbers.
configure_file("version.h.in" "${CMAKE_CURRENT_LIST_DIR}/inc/hocon/version.h")

# Generate files for Doxygen
configure_file("Doxyfile.in" "${CMAKE_CURRENT_LIST_DIR}/Doxyfile")
configure_file("namespaces.dox.in" "${CMAKE_CURRENT_LIST_DIR}/docs/namespaces.dox")

# Set C++ compile flags based on project settings.
set(CMAKE_CXX_FLAGS ${${PROJECT_NAME_UPPER}_CXX_FLAGS})

# Set prefix for logging messages.
leatherman_logging_namespace("puppetlabs.${PROJECT_NAME}")

# Setup compiling the library.
include_directories(inc ${Boost_INCLUDE_DIRS} ${LEATHERMAN_INCLUDE_DIRS})

set(PROJECT_SOURCES
    src/values/config_object.cc
    src/values/simple_config_object.cc
    src/nodes/abstract_config_node.cc
    src/nodes/config_node_include.cc
    src/nodes/config_node_simple_value.cc
    src/nodes/config_node_single_token.cc
    src/nodes/config_node_comment.cc
    src/nodes/config_node_path.cc
    src/nodes/config_node_complex_value.cc
    src/nodes/config_node_field.cc
    src/nodes/config_node_object.cc
    src/nodes/config_node_array.cc
    src/nodes/config_node_concatenation.cc
    src/nodes/config_node_root.cc
    src/values/config_value.cc
    src/values/config_boolean.cc
    src/values/config_number.cc
    src/values/config_long.cc
    src/values/config_double.cc
    src/values/config_null.cc
    src/values/config_string.cc
    src/values/config_int.cc
    src/values/config_reference.cc
    src/path.cc
    src/path_builder.cc
    src/path_parser.cc
    src/token.cc
    src/tokens.cc
    src/tokenizer.cc
    src/simple_config_document.cc
    src/simple_config_origin.cc
    src/config_util.cc
    src/config_parse_options.cc
    src/config_render_options.cc
    src/config_document_parser.cc
    src/config_document_factory.cc
    src/config_parser.cc
    src/parseable.cc
    src/simple_include_context.cc
    src/simple_includer.cc
    src/config_resolve_options.cc
    src/config.cc
    src/default_transformer.cc
    src/substitution_expression.cc
    src/values/simple_config_list.cc
    src/values/config_delayed_merge.cc
    src/values/config_delayed_merge_object.cc
    src/resolve_context.cc
    src/resolve_source.cc
    src/values/config_concatenation.cc
    src/config_value_factory.cc)


## An object target is generated that can be used by both the library and test executable targets.
## Without the intermediate target, unexported symbols can't be tested.
add_library(libprojectsrc OBJECT ${PROJECT_SOURCES})
set_target_properties(libprojectsrc PROPERTIES POSITION_INDEPENDENT_CODE true)

add_library(lib${PROJECT_NAME} $<TARGET_OBJECTS:libprojectsrc>)
set_target_properties(lib${PROJECT_NAME} PROPERTIES VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
target_link_libraries(lib${PROJECT_NAME}
    ${LEATHERMAN_LIBRARIES}
    ${Boost_LIBRARIES}
    )

# Generate the export header for restricting symbols exported from the library.
# Restricting symbols has several advantages, noted at https://gcc.gnu.org/wiki/Visibility.
symbol_exports(lib${PROJECT_NAME} "${CMAKE_CURRENT_LIST_DIR}/inc/hocon/export.h")

# This correctly handles DLL installation on Windows.
leatherman_install(lib${PROJECT_NAME})
install(DIRECTORY inc/hocon DESTINATION include)

add_subdirectory(tests)

=== locales/CMakeLists.txt ===
gettext_templates(${CMAKE_CURRENT_SOURCE_DIR} ${ALL_SOURCES})
gettext_compile(${CMAKE_CURRENT_SOURCE_DIR} share/locale)
SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM TRUE)
export_var(GETTEXT_ENABLED)

=== debian/changelog ===
cpp-hocon (0.3.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Disable -Werror. (Closes: #1096468)
  * Drop obsolete setting of -Wl,--as-needed (now default).

 -- Adrian Bunk <bunk@debian.org>  Sun, 21 Sep 2025 13:40:42 +0300

cpp-hocon (0.3.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061905

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 17:36:41 +0000

cpp-hocon (0.3.0-1) unstable; urgency=medium

  * New upstream release (Closes: #970379)
    + Bump SONAME to 0.3.0
    - Drop fix-gcc-8-ftbfs.patch; changes included upstream
  * Bump Standards-Version to 4.5.0; no changes needed
  * Bump dh compat to 13
    - Drop the redundant override of dh_missing, as --fail-missing is on by
      default
  * d/copyright: bump debian/ years

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 25 Aug 2020 13:48:42 +0300

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: cpp-hocon
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
+Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
 Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
-Build-Depends: debhelper (>= 11~),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  cmake,
  libleatherman-dev,
  libboost-program-options-dev,
  catch (>= 1.10~),
-Standards-Version: 4.2.0
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/puppetlabs/cpp-hocon
 Vcs-Git: https://salsa.debian.org/puppet-team/cpp-hocon.git
@@ -18,7 +17,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcpp-hocon0.1.7 (= ${binary:Version}), ${misc:Depends}
+Depends: libcpp-hocon0.3.0t64 (= ${binary:Version}), ${misc:Depends}
 Description: C++ port of the TypesafeConfig library -- development files
  cpp-hocon is a port of the TypsafeConfig library to C++. It provides support
  for the HOCON configuration file format. HOCON aims to keep the semantics
@@ -27,7 +26,10 @@
  .
  This package contains cpp-hocon's development headers.
 
-Package: libcpp-hocon0.1.7
+Package: libcpp-hocon0.3.0t64
+Provides: ${t64:Provides}
+Replaces: libcpp-hocon0.3.0
+Breaks: libcpp-hocon0.3.0 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -7,10 +7,7 @@
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_CXXFLAGS_MAINT_PREPEND = -Wno-error
 
 %:
 	dh $@
-
-override_dh_missing:
-	dh_missing --fail-missing

=== debian/watch ===
version=3
https://github.com/puppetlabs/cpp-hocon/releases .*/([\d.]+)/cpp-hocon.tar.gz
